
# this Makefile generator for current directory and all subdirectories

STD_VERSION=c++20       ## EDIT: try c++17 (should work except c++20/)
GCC_VERSION= #-13.1     ## EDIT: leave empty for default system g++
# when using locally installed GCC, we expect
# correct setting of LD_LIBRARY_PATH to run the programs (make run)
## TODO: improve tests

# Makefile for all directories
gener() {
echo
echo "CXXFLAGS = -std=${STD_VERSION} -g -O2 -Wall"
echo "CXX      = g++${GCC_VERSION}"
echo "LDLIBS   = -lpthread -lm"  # some examples need additional library
echo
echo "############################################################"
echo "# C++ programs:"
for i in *.cc; do
    if [ -f "$i" ]; then
        echo "PROGS += ${i%%.cc}"
    fi
done
#echo "# C programs:"
#for i in *.c; do
#    if [ -f "$i" ]; then
#        echo "PROGS += ${i%%.c}"
#    fi
#done
echo "############################################################"
echo
echo "all: \$(PROGS)"
echo
echo "run: \$(PROGS)"
echo "	@for i in \$(PROGS); do echo \"===== ./\$\${i} =====\"; ./\$\${i}; done"
echo "	@echo"
echo
echo "clean:"
echo "	rm -f \$(PROGS)"
echo
}

for d in */; do
    echo $d
    (cd $d; gener >Makefile)
done

# main Makefile
gener_index() {
echo "############################################################"
echo "# Makefile"
echo "############################################################"

echo "CXXFLAGS = -std=${STD_VERSION} -g -O2 -Wall"
echo "CXX      = g++${GCC_VERSION}"     ### TODO: ?= does not work here
echo "LDLIBS   = -lpthread -lm"  # some examples need additional library
echo "export CXXFLAGS CXX LDLIBS"

echo
echo "all:"
for d in */; do
    if [ -f "$d/Makefile" ]; then
        echo "	make -C $d"
    fi
done
echo
echo "clean:"
for d in */; do
    if [ -f "$d/Makefile" ]; then
        echo "	make -C $d clean"
    fi
done
echo
echo "pack: clean"
echo '	(                                               \'
echo '	NAME=$$(basename $$(pwd)); cd ..;               \'
echo '	tar czvf $$NAME-$$(date -I).tar.gz ./$$NAME/    \'
echo '	)'
echo
}

gener_index >Makefile

