
// steady_clock example

#include <iostream>
#include <chrono>

int main ()
{
    using namespace std::chrono;

    const int N=10;
    duration<double> sum{};

    for(int i=0; i<N; ++i) {
        std::cout << "Printing out 10 stars: ";

        steady_clock::time_point t1 = steady_clock::now();
        for (int i=0; i<10; ++i) std::cout << "*";
        steady_clock::time_point t2 = steady_clock::now();

        auto time_span = duration_cast<duration<double>>(t2 - t1);
        sum+=time_span;

        std::cout << " took me " << time_span.count() << " seconds.";
        std::cout << std::endl;
    }

    std::cout << "Average " << sum.count()/N << " seconds.";
    std::cout << std::endl;
}

