
#include <iostream>

// every object of type struct sse_t will be aligned to 16-byte boundary
// (note: needs support for DR 444)
struct S1 {
  alignas(16) int data[4];
};

// struct data aligned to 32-byte boundary
struct S2 {
  int n;
  alignas(32) char cacheline[32]; // over-aligned array
};

int main(void)
{
    std::cout << "sizeof(struct S2) = " << sizeof(struct S2) <<
                 " (1 char + 31 B padding + 32 B array)\n";

    std::cout << "alignment of S2: " << alignof(struct S2) << "\n";

    alignas(256) struct S2 d;

    std::cout << "address: " << &d << "\n";
}

