
// http://en.cppreference.com/w/cpp/io/ios_base/failure

#include <iostream>
#include <fstream>

int main() {
    try {
        std::ifstream f("filename, which doesn't exist");
        // ...
        f.exceptions(f.failbit);
    }
    catch (const std::ios_base::failure& e) {
        std::cout << "ios_base::failure\n"
                  << "Explanatory string: \"" << e.what() << "\"\n"
                  << "Error code: " << e.code() << '\n';
    }
}

