
#include <iostream>
#include <ratio>

int main()
{
    using two_third = std::ratio<2, 3>;
    using one_sixth = std::ratio<2, 12>;

    using r = std::ratio_multiply<two_third, one_sixth>;
    std::cout << "2/3 * 1/6 = " << r::num << '/' << r::den << '\n';

    using sum = std::ratio_add<two_third, one_sixth>;
    std::cout << "2/3 + 1/6 = " << sum::num << '/' << sum::den << '\n';

    using diff = std::ratio_subtract<two_third, one_sixth>;
    std::cout << "2/3 - 1/6 = " << diff::num << '/' << diff::den << '\n';

    using d = std::ratio_divide<two_third, one_sixth>;
    std::cout << "2/3 / 1/6 = " << d::num << '/' << d::den << '\n';

    if (std::ratio_less<two_third, one_sixth>::value) {
        std::cout << "2/3 < 1/6\n";
    }
    if (std::ratio_greater<two_third, one_sixth>::value) {
        std::cout << "2/3 > 1/6\n";
    }
    if (std::ratio_not_equal<two_third, one_sixth>::value) {
        std::cout << "2/3 != 1/6\n";
    }
}

