//
// Example of casts in multiple inheritance
//

#include <iostream>
using namespace std;

int n = 0; 

class X {
  int i;
  public: 
  X(): i(++n) {}
};

class A : public virtual X {
  int a;
  public: 
  A(): a(++n) {}
};

class B : public virtual X {
  int b;
  public: 
  B(): b(++n) {}
};

class C : public A, public B {
  int c;
  public: 
  C(): c(++n) {}
};

int main() {
  C c;

  typedef X* Ptr;
  void *px0 = &c;    // address of object

  Ptr px1 = static_cast<Ptr>(&c);      // address of subobject
  Ptr px2 = reinterpret_cast<Ptr>(&c); // unusable
  Ptr px3 = Ptr(&c);

  cout << "&c  = " << px0 << "   void*\n";
  cout << "px1 = " << px1 << "   static_cast\n";
  cout << "px2 = " << px2 << "   reinterpret_cast\n";
  cout << "px3 = " << px3 << "   Ptr(void*) [same as static_cast]\n";

}
