// dtr.cc -- destruktory 
//
// Destruktor lze volat explicitn s pouitm pln kvalifikovanho
// jmna destruktoru (pouv se jen vjimen).
//

#include <iostream>
#include <cstdlib>
using namespace std;

class X {
  const char *const name;
public:
  X(const char *const name);
  ~X();                         // destruktor pro tdu X
};

X::X(const char *const nam) : name(nam) {
  cout << "Konstruktor objektu " << name << endl;
}

X::~X() {
  cout << "Destruktor objektu " << name << endl;
}

//// definice specilnho opertoru new 
//// GCC >= 3.0: je implicitn definovn!
//void * operator new(size_t size, void * ptr) { // extra parametr - ukazatel
//  return ptr; // umstme objekt na zadanou pozici
//}

char buffer[sizeof(X)];           // zde bude vytvoen objekt tdy X

int main() {
  X *ptr = new X("*ptr"); // bn dynamick pidlen -- neznm adresa

  X *exact_ptr;
  exact_ptr = new(buffer) X("buffer"); // objekt je umstn do pole buffer,
                                       // vol se konstruktor objektu
  // ...
  exact_ptr->X::~X();   // pm voln destruktoru 
                        // pro zruen objektu *exact_ptr
                        // (nelze volat standardn opertor delete)
  // ...
  delete ptr;           // opertor delete pouit pro ruen ptr

  return 0;
}

