
// source:
// http://stackoverflow.com/questions/55510/when-do-function-level-static-variables-get-allocated-initialized

#include <string>
#include <iostream>

using namespace std;

class test
{
    public:
        test(const char *name) : _name(name) {
            cout << _name << " created" << endl;
        }

        ~test() {
            cout << _name << " destroyed" << endl;
        }

        string _name;
        static test t; // static member
};

test test::t("static in class");

test t("global variable");

void f()
{
    cout << "=function start" << endl;
    static  test t("=static variable");
    static int num = 10 ; // POD type, init before entering main()
    test t2("=local variable");
    cout << "=function end" << endl;
}

int main()
{
    cout << "*main start" << endl;
    test t("*local to main");
    f();
    cout << "*main end" << endl;
}

