
// test of basic std::string operations
#include <iostream>
#include <string>

int main ()
{
  using std::cout;
  using std::string;

  string str("hello.");

  str.front() = 'H';            // str[0]
  str.back() = '!';             // str[str.length()-1]
  cout << str << "\n";

  str.insert(5,", World");      // insert at position
  cout << str << "\n";

  str.erase(5);                 // erase from position (default=to end)
  cout << str << "\n";

  str.replace(0/*pos*/, 0/*len*/, "Ahoj == ");
  cout << str << "\n";

  size_t len = str.length();
  for(int i=0; i<len/2; i++)
    cout << ' ';
  cout << "^\n";
  cout << "length=" << len << ", str[length/2]='" << str[len/2] << "'\n";

  cout << "\n";
  cout << "string::npos is " << string::npos << "\n";
  cout << str << "\n";
  size_t pos = str.find(" == ");
  if(pos==string::npos)
    cout << "NOT ";
  cout << "FOUND\n";
  cout << "position of ' == ' in string is " << pos << "\n";
  size_t pos2 = str.find(" != ");
  if(pos2==string::npos)
    cout << "NOT ";
  cout << "FOUND\n";
  cout << "position of ' != ' in string is " << pos2 << "\n";

  cout << "\n";
}
