
// g++ icp-thread-demo1.cc -lpthread

#include <iostream>
#include <thread>
#include <vector>
#include <numeric>

using namespace std;

double sum(const vector<double> & v) {
    double sum=0;
    sum = accumulate(begin(v), end(v), sum);
    return sum;
}

double product(const vector<double> & v) {
    double p=1.0;
    //p=accumulate(begin(v),end(v),p,[](double a, double b){return a*b;});
    p = accumulate(begin(v), end(v), p, multiplies<double>());
    return p;
}

int main() {
    double res1, res2;
    vector<double> v{ 1, 2, 3, 4, 5 };

    // parallel computation
    thread t1{ [&]{res1=sum(v);} };
    thread t2{ [&]{res2=product(v);} };
    t1.join();
    t2.join();

    cout<< "sum=" << res1 << "\n";
    cout<< "product=" << res2 << "\n";

}
