
// simple test of wide character usage
// we use UNICODE code point U+1F34C = 🍌

#include <iostream>
#include <string>

int main() {
    using namespace std;
    int      banana0 = '🍌';    // warning: multi-character character constant
    wchar_t  banana1 = L'🍌';   // problem of wchar_t size (16 or 32 bita)
    char32_t banana2 = U'\U0001F34C';   // correct
    char32_t banana3 = U'🍌';           // correct (iff correct source encoding)
    string u8str{"🍌"};
    cout << "Glyph:\n\n";
    cout << u8str << "\n\n";    // needs UTF-8 terminal
    cout << hex;                // switch to hexadecimal notation

    for(auto c: u8str)          // print all bytes in string
        cout << (static_cast<unsigned>(c)&0xFF) << " ";
    cout << " (UTF-8 sequence)\n\n";

    cout << unsigned(banana0)
         << " (multicharacter literal '...', implementation-defined)\n";
    cout << unsigned(banana1)
         << " (wide-character literal L'...', implementation-defined)\n";
    cout << unsigned(banana2)
         << " (char32_t ISO10646 code-point U'\\U000.....')\n";
    cout << unsigned(banana3)
         << " (char32_t ISO10646 code-point U'\\U000.....')\n\n";
}
