
// test of std::char_traits::length() using 3 different arrays of characters

#include <iostream>   // std::cout
#include <string>     // std::char_traits

int main ()
{
  //const char * s = u8"String literal ěščřžýáíé \U0001F596";  // UTF-8 (c++20 problem)
  const char * s = "String literal ěščřžýáíé \U0001F596";  // UTF-8
  std::cout << "test string = \"" << s << "\"\n";
  std::cout << "UTF-8 string length = ";
  std::cout << std::char_traits<char>::length(s);
  std::cout << " characters of type char.\n";

  const char16_t * s16 = u"String literal ěščřžýáíé \U0001F596"; // UTF-16/UCS2
  std::cout << "char16_t string length = ";
  std::cout << std::char_traits<char16_t>::length(s16);
  std::cout << " characters of type char16_t.\n";

  const char32_t * s32 = U"String literal ěščřžýáíé \U0001F596"; // UTF-32/UCS4
  std::cout << "char32_t string length = ";
  std::cout << std::char_traits<char32_t>::length(s32);
  std::cout << " characters of type char32_t.\n";
}
